from modules import core, isometric, entities, gui, elements, hud, level_loader
from modules.core import *
from modules.elements import *
from modules.hud import *

try:
    import psyco
    psyco.background()
except:
    print "now psyco installed here..."

def main(level):
    pygame.init()
    screen=pygame.display.set_mode([640,480])#, FULLSCREEN)
    screen.fill([0,0,0])

    for i in level['plants']:
        level['plants'][i][0]=core.load_image(os.path.join('data','objects',
                                                            level['plants'][i][0]),
                                                   alpha=True)

    world=isometric.IsoMap(level['map'],
                           {'g':core.load_image(os.path.join('data','tiles','grass.bmp'),-1)},
                           100,
                           core.load_image(os.path.join('data','tiles','tile_mask.bmp')))

    player=Player(world, level)
    enemy=Enemy(world, level)

    game_win_plots=level['win_num_plots']

    pygame.mixer.music.load(os.path.join('data','assets','testing.ogg'))
    pygame.mixer.music.play(-1)

    hud=HUD(player)
    hovering=Hovering_on()
    mouse=Mouse()

    world.move(-400,-100)
    clock=pygame.time.Clock()
    pygame.key.set_repeat(9)
    while 1:
        clock.tick(90)
        for event in pygame.event.get():
            hud.event(event)
            if event.type==KEYDOWN:
                if event.key==K_ESCAPE:
                    print clock.get_fps()
                    pygame.quit()
                    return

                if event.key==K_s:
                    pygame.image.save(screen, 'screenie4.bmp')

            if event.type==QUIT:
                print clock.get_fps()
                pygame.quit()
                return

            if event.type==MOUSEBUTTONDOWN:
                if event.button==1:
                    pos=world.get_tile_at_pos(pygame.mouse.get_pos())
                    if pos==None:
                        continue

                    if hud.mouse_mode=='buy_plot':
                        if not pos in [enemy.entity.pos]+enemy.plots.STs:
                            player.buy_plot(pos, world)
                    if hud.mouse_mode=='buy_plant':
                        if not pos in [enemy.entity.pos]+enemy.plots.STs:
                            player.buy_plant(pos, world, hud.selected_plant)
                    if hud.mouse_mode=='harvest':
                        player.harvest(pos)
                    if hud.mouse_mode=='nourish':
                        player.nourish(pos, world)
                    if hud.mouse_mode=='lightning':
                        player.cast_lightning_bolt(pos, world, enemy)

                if event.button==3:
                    hud.mouse_mode='select'
                    hud.plant_list_on=False

        mp = pygame.mouse.get_pos()
        if mp[0]==0:
            world.move(-1,0)
        if mp[0]==639:
            world.move(1,0)

        if mp[1]==0:
            world.move(0,-1)
        if mp[1]==479:
            world.move(0,1)


        screen.fill([0,0,0])
        world.render(screen)

        hovering.render(screen, hud, world)

        player.update(world)

        enemy.play(clock.get_time(), world, player)
        enemy.update(world)

        if len(player.plots.STs)==game_win_plots:
            print "YOU WON!"
            pygame.quit()
            return

        if len(enemy.plots.STs)==game_win_plots:
            print "YOU LOST :{"
            pygame.quit()
            return

        render_all(screen, player, enemy)

        hud.render(screen, player, enemy)
        if hud.do_quit:
            print clock.get_fps()
            pygame.quit()
            return

        mouse.render(screen, hud)

        pygame.display.flip()

main(level_loader.load_dict(os.path.join('levels','test_level.txt')))
